package de.mdelab.mlsdm.interpreter.eclipse.searchModel;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.expressions.interpreter.core.ExpressionsInterpreterException;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlsdm.Activity;
import de.mdelab.mlsdm.ActivityEdge;
import de.mdelab.mlsdm.ActivityNode;
import de.mdelab.mlsdm.interpreter.facade.MLSDMMetamodelFacadeFactory;
import de.mdelab.mlsdm.interpreter.notifications.MLSDMNotificationEmitter;
import de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.MLSDMSearchModelBasedMatcher;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.SDMException;
import de.mdelab.sdm.interpreter.core.eclipse.MLSDMEclipseExpressionsInterpreterManager;
import de.mdelab.sdm.interpreter.core.variables.NotifierVariablesScope;

public class MLSDMEclipseSearchModelBasedMatcher extends MLSDMSearchModelBasedMatcher{

	public MLSDMEclipseSearchModelBasedMatcher(
			final StoryPattern storyPattern,
			final NotifierVariablesScope<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> variablesScope,
			final ClassLoader classLoader,
			final MLSDMNotificationEmitter notificationEmitter)
	throws ExpressionsInterpreterException, SDMException {
		super(	storyPattern,
				variablesScope,
				MLSDMMetamodelFacadeFactory.INSTANCE,
				new MLSDMEclipseExpressionsInterpreterManager<Activity, ActivityNode, ActivityEdge, StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression>(
						MLSDMMetamodelFacadeFactory.INSTANCE.getExpressionFacade(),
						classLoader, 
						notificationEmitter ).registerExpressionInterpreters(),
				new MLSDMEclipseExpressionAnalyzerManager(MLSDMMetamodelFacadeFactory.INSTANCE.getExpressionFacade()),
				null,
				notificationEmitter );
	}

}
