package de.mdelab.mlsdm.interpreter.facade;

import de.mdelab.expressions.interpreter.core.IExpressionsFacade;
import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlexpressions.MLStringExpression;

/**
 * 
 * @author Stephan Hildebrandt
 * 
 */
public class MLSDMExpressionFacade implements IExpressionsFacade<MLExpression>
{
	@Override
	public String getExpressionLanguage(final MLExpression expression)
	{
		assert expression != null;

		return expression.getExpressionLanguage();
	}

	@Override
	public String getExpressionLanguageVersion(final MLExpression expression)
	{
		return "1.0";
	}

	@Override
	public String getExpressionString(final MLExpression expression)
	{
		if (expression instanceof MLStringExpression)
		{
			return ((MLStringExpression) expression).getExpressionString();
		}
		else
		{
			return expression.toString();
		}
	}

	@Override
	public Object getExpressionAST(final MLExpression expression)
	{
		assert expression != null;
		assert expression instanceof MLStringExpression;

		// final StringExpressionASTHolderAdapter adapter =
		// (StringExpressionASTHolderAdapter)
		// MLSDMInterpreterExpressionAsdapterFactory.INSTANCE
		// .adapt(expression,
		// MLSDMInterpreterExpressionAsdapterFactory.INSTANCE);
		//
		// return adapter.getAST();

		return expression.getAst();
	}

	@Override
	public void setExpressionAST(final MLExpression expression, final Object expressionAST)
	{
		assert expression != null;
		assert expression instanceof MLStringExpression;
		assert expressionAST != null;

		// final StringExpressionASTHolderAdapter adapter =
		// (StringExpressionASTHolderAdapter)
		// MLSDMInterpreterExpressionAsdapterFactory.INSTANCE
		// .adapt(expression,
		// MLSDMInterpreterExpressionAsdapterFactory.INSTANCE);
		//
		// assert adapter != null;
		//
		// adapter.setAST(expressionAST);

		expression.setAst(expressionAST);
	}
}
