package de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.strategy;

import org.eclipse.emf.ecore.EClassifier;
import org.eclipse.emf.ecore.EStructuralFeature;

import de.mdelab.mlexpressions.MLExpression;
import de.mdelab.mlstorypatterns.AbstractStoryPatternLink;
import de.mdelab.mlstorypatterns.AbstractStoryPatternObject;
import de.mdelab.mlstorypatterns.StoryPattern;
import de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.PatternConstraint;

/**
 * This is a cost strategy encoding a cost model where the
 * matching cost is determined by the cardinality of the pattern
 * constraint's current matching action's result set.
 * 
 * @author Matthias.Barkowsky
 *
 */
public class MLSDMCardinalityMatchingCostStrategy implements MLSDMMatchingCostStrategy {

	/* (non-Javadoc)
	 * @see de.mdelab.mlsdm.interpreter.patternMatcher.searchModelBased.strategy.cost.MLSDMMatchingCostStrategy#calculateMatchingCost(de.mdelab.sdm.interpreter.core.patternmatcher.searchModelBased.PatternConstraint)
	 */
	@Override
	public double calculateMatchingCost(
			PatternConstraint<StoryPattern, AbstractStoryPatternObject, AbstractStoryPatternLink, EClassifier, EStructuralFeature, MLExpression> patternConstraint) {
		return patternConstraint.getCardinality();
	}

	@Override
	public void initialize() {
		
	}

}
