package de.mdelab.mlsdm.interpreter.searchModel.patternMatcher.strategy.grgen;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class GRGENPlanGraph {

	public List<GRGENPlanGraphNode> nodes;
	public List<GRGENPlanGraphEdge> edges;
	public GRGENPlanGraphNode root;

	public GRGENPlanGraph() {
		this.nodes = new ArrayList<GRGENPlanGraphNode>();
		this.edges = new ArrayList<GRGENPlanGraphEdge>();
	}
	
	public Map<Object, Object> cloneWithMapping() {
		Map<Object, Object> cloneMappings = new HashMap<Object, Object>();
		
		GRGENPlanGraph clone = new GRGENPlanGraph();
		cloneMappings.put(clone, this);
		cloneMappings.put(this, clone);
		
		for(GRGENPlanGraphNode node:nodes) {
			GRGENPlanGraphNode cloneNode = new GRGENPlanGraphNode(node.name, node.searchModelElement);
			clone.nodes.add(cloneNode);

			cloneMappings.put(cloneNode, node);
			cloneMappings.put(node, cloneNode);
		}
		clone.root = (GRGENPlanGraphNode) cloneMappings.get(root);
		
		for(GRGENPlanGraphEdge edge:edges) {
			GRGENPlanGraphEdge cloneEdge = new GRGENPlanGraphEdge((GRGENPlanGraphNode) cloneMappings.get(edge.source), (GRGENPlanGraphNode) cloneMappings.get(edge.target), edge.cost);
			cloneEdge.action = edge.action;
			clone.edges.add(cloneEdge);

			cloneMappings.put(cloneEdge, edge);
			cloneMappings.put(edge, cloneEdge);
		}
		
		return cloneMappings;
	}
}
